#include "me_iostm8s003f3.h"
#include "uart.h"
#define CHANNEL 2

void SetDutyPWM (int persent)
{
    //int val = 65535 * persent/100;
     int val = persent * 64;
    TIM2_CCR2H = (val >> 8);
    TIM2_CCR2L = (val & 0XFF);  
}


void intiTimer (void)
{
  CLK_PCKENR1 = 0xFF; // Enable Clock for Timer
  TIM2_PSCR.PSC = 0X01; // fCK_CNT = fCK_PSC/2^(PSCR[3:0])   -- note : fCK_PSC = fmaster
  TIM2_CCMR2.OC2M = 0X07; //PWM Mode
  TIM2_CCMR2.CC2S = 00;   // CC2 Chanels as output PWM
  TIM2_CCER1.CC2P =  1 ;   // OC2 Active Low
  TIM2_CCER1.CC2E =  1 ;   // Timer OutPut to Pin PD.3
//  TIM2_IER_UIE = 1;     // ENABLE UPDATE INTERRUPT
  TIM2_CR1.CEN = 1; // ENABLE Timer 2
//  asm ("rim");// ENABLE iNTERRUPT
  
}


void delay (void)
{
  long int Counter = 10000;
  while (Counter--);
}

void ADC_init (void)
{
         /* Configure the data alignment */
       ADC_CR2.ALIGN = 1;  // Data alignment right
       /* Set the continuous conversion mode */
       ADC_CR1.CONT = 1;
       /* Select the ADC1 channel */
       ADC_CSR.CH = CHANNEL; // channel 2
       /* Select the prescaler division factor according to ADC1_PrescalerSelection values */
       ADC_CR1.SPSEL = 0x7;  // Prescaler selection fADC1 = fcpu/18  
       /* Disable the selected external trigger */
       ADC_CR2.EXTTRIG = 0;
       /* Set the selected external trigger */
       ADC_CR2.EXTSEL = 1;  //Conversion from External interrupt on ADC_ETR pin
       //ADC Schmitt trigger disable register low
       ADC_TDRL |= (0x01 << CHANNEL); // channel 0 Enable
       /* Enable the ADC1 peripheral */
       ADC_CR1.ADON  =  1;
}

unsigned int ADC_GetValue (void)
{
   unsigned int temp = 0;
     /* Enable the ADC1 peripheral */
     ADC_CR1.ADON  =  1;
    /* waite for End conversion */ 
    while(!ADC_CSR.EOC);
    /* read MSB */
    temp = ADC_DRH; 
    /* MSB or LSB */
    temp = ((temp << 8) | ADC_DRL ); 
    /* Repaet conversion*/ 
    ADC_CSR.EOC = 0;
    return temp;
}
void main( void )
{
       unsigned int ADC_val;
       CLK_CKDIVRA = 0x00;
       CLK_PCKENR1 = 0xFF; // Enable peripherals

       ADC_init();
       intiTimer();
       uart_init();
       uart_send_string("In the Name of GOD\n");
        while(1)
        {
            ADC_val = ADC_GetValue();
	    SetDutyPWM (ADC_val);
            uart_send_num (ADC_val); uart_send_char ('\n');
            delay();
        }

	

}
